//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include <string.h>
#include <stdio.h>

#include "motorpp.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPort"
#pragma resource "*.dfm"


#define CHART_POINTS 200

void ParseMsg (char *msg);
void SendMsg(char *msg);

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btConnectClick(TObject *Sender)
{
   ComPort1->Close();
   ComPort1->BaudRate = br9600;
   ComPort1->Parity->Bits = prNone;
   ComPort1->DataBits = dbEight;
   ComPort1->StopBits = sbOneStopBit;
   ComPort1->ShowSetupDialog();

    ComPort1->Open();
    if (ComPort1->Connected) {
    } else {
      ShowMessage("I can't use that serial port\nChech it's existence and/or if it's free.");
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btDOL_1Click(TObject *Sender)
{
   ComPort1->WriteStr("#DOL02021\x0D");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btDOL_0Click(TObject *Sender)
{
   ComPort1->WriteStr("#DOL02020\x0D");
}
//---------------------------------------------------------------------------
char data_buff[10000]="";

void __fastcall TForm1::ComPort1RxChar(TObject *Sender, int Count)
{
   AnsiString a;
   bool something_found;
   unsigned int pos1,pos2;

   char msg[1000];

   ComPort1->ReadStr(a,Count);
   strcat(data_buff,a.c_str());

   do {
     something_found = false;  // nothing found flag

     /* search for mesage */
     for (pos1=0;pos1< strlen(data_buff);pos1++) {
        if (data_buff[pos1] == '#') {
           break;
        }
     }

     /* if found start, then find end of message */
     if (pos1 < strlen(data_buff)) {
        for (pos2=pos1+1;pos2< strlen(data_buff);pos2++) {
           if (data_buff[pos2] == '\x0D') {
              break;
           }
        }
     }

     /* if complete message found, then show it */
     if ((pos1 < strlen(data_buff)) && (pos2 < strlen(data_buff))) {
         something_found = true;
         strncpy(msg,&data_buff[pos1],pos2-pos1);
         msg[pos2-pos1]='\0';
         mmResponse->Lines->Add(msg);
         ParseMsg(msg);
         strcpy(data_buff,&data_buff[pos2+1]);  // delete message
     }
   } while (something_found);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::btDILClick(TObject *Sender)
{
   //   ComPort1->WriteStr("#DIL0200\x0D");
   SendMsg("#DIL0200\x0D");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::bfDOFClick(TObject *Sender)
{
   ComPort1->WriteStr("#DOF2020001000\x0D");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
   char buff[100];
   int low_time, high_time, degrees;

   // servo position
   degrees = ScrollBar1->Position;

   high_time = 500 + ((2500.0-500.0)/180.0) * degrees;
   low_time = 10000;

   sprintf(buff,"#DOF20%04X%04X\x0D",high_time, low_time);
   //Label1->Caption = buff;
   Label1->Caption = degrees;
   ComPort1->WriteStr(buff);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btDIFClick(TObject *Sender)
{
   //ComPort1->WriteStr("#DIF00\x0D");
   SendMsg("#DIF10\x0D");
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
   int i;
   
   for(i=0;i<CHART_POINTS;i++) {
      Series1->AddXY(i,0.0,"",(TColor)clTeeColor);
   }
}
//---------------------------------------------------------------------------
void ParseMsg (char *msg) {

   int i;
   int value;

   if (strlen(msg)>=3) {   // has data
      if (msg[1] == '!') { // msg is correct
         sscanf(&msg[2],"%d",&value);
         for (i=1;i<CHART_POINTS;i++) {
            Form1->Series1->YValues->Value[i-1] = Form1->Series1->YValues->Value[i];
         }
         Form1->Series1->YValues->Value[CHART_POINTS-1]= value;
         Form1->Series1->Repaint();
      }
   }
}

//---------------------------------------------------------------------------
char save_msg[1000] = "";

void SendMsg(char *msg) {
   strcpy(save_msg,msg);
   Form1->ComPort1->WriteStr(msg);
}
void __fastcall TForm1::btAutoRepeatClick(TObject *Sender)
{
   int tmr;
   if (btAutoRepeat->Caption == "AutoRepeat OFF") {
      btAutoRepeat->Caption = "AutoRepeat ON";
      tmr = lbedTime->Text.ToInt();
      Timer1->Interval = tmr;
      Timer1->Enabled = true;
   } else {
      btAutoRepeat->Caption = "AutoRepeat OFF";
      Timer1->Enabled = false;   
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
   ComPort1->WriteStr(save_msg);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btAISClick(TObject *Sender)
{
   SendMsg("#AIS4004\x0D");   // P2.5 is the potentiometer
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpDown1Changing(TObject *Sender, bool &AllowChange)
{
   int tmr;

   tmr = lbedTime->Text.ToInt();
   Timer1->Interval = tmr;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
   char buff[100];
   int duty;

   // servo position
   duty = ScrollBar2->Position;

   sprintf(buff,"#PWM30%03d0\x0D",duty);
   //Label1->Caption = buff;
   lbPWM->Caption = duty;
   ComPort1->WriteStr(buff);
}
//---------------------------------------------------------------------------

void CD_SendStr(char *cad) {
   Form1->ComPort1->WriteStr(cad);
}


void __fastcall TForm1::Button2Click(TObject *Sender)
{
   motpp_r();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   motpp_cr(); 
}
//---------------------------------------------------------------------------

int motor_cnt;
#define MOTOR_STEPS  100
void __fastcall TForm1::Button3Click(TObject *Sender)
{
   TimerMotor->Interval = 20;
   TimerMotor->Enabled = true;
   motor_cnt = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TimerMotorTimer(TObject *Sender)
{
   motor_cnt++;

   if (motor_cnt > 0) {
      motpp_r();
   } else {
      motpp_cr();
   }

   if (motor_cnt == MOTOR_STEPS) {
         motor_cnt = -MOTOR_STEPS;
   }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   TimerMotor->Enabled = false;
}
//---------------------------------------------------------------------------

