//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;


unsigned char CD_HexaToNum(char chr, unsigned char *val);
unsigned char CD_HexaStrTo_u8(unsigned char *strx, unsigned char siz, unsigned char *val);
unsigned char CD_HexaStrTo_u16(unsigned char *strx, unsigned char siz, unsigned int *val);
unsigned char CD_HexaStrTo_u32(unsigned char *strx, unsigned char siz, unsigned long *val);

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   // kk
   unsigned char c;
   unsigned int u;
   int i;
   unsigned long ul;

   if (CD_HexaToNum(Edit1->Text.c_str()[0], &c)) {
      ShowMessage("Fallo convirtiendo CD_HexaToNum");
   } else {
      i = c;
      Label1->Caption = i;
   }

   if (CD_HexaStrTo_u8(Edit1->Text.c_str(),2,&c)) {
      ShowMessage("Fallo convirtiendo CD_HexaStrTo_u8");
   } else {
      i = c;
      Label2->Caption = i;
   }

   if (CD_HexaStrTo_u16(Edit1->Text.c_str(),4,&u)) {
      ShowMessage("Fallo convirtiendo CD_HexaStrTo_u16");
   } else {
      i = u;
      Label3->Caption = i;
   }

   if (CD_HexaStrTo_u32(Edit1->Text.c_str(),8,&ul)) {
      ShowMessage("Fallo convirtiendo CD_HexaStrTo_u32");
   } else {
      i = ul;
      Label4->Caption = i;
   }

}
//---------------------------------------------------------------------------


/****************************************************************************/
/* calculates the numeric value of an hexa digit represented in ASCII
   parameters:
      char -> character to evaluate
      val -> pointer where the conversion is returned
   returns:
      0 -> conversion OK, <>0 fail conversion
   modifies:
      val
*/
unsigned char CD_HexaToNum(char chr, unsigned char *val) {
   if ((chr >= '0') && (chr <= '9')) {
      *val = chr-'0';
      return(0);
   } else if ((chr >= 'A') && (chr <= 'F')) {
      *val = chr-'A'+10;
      return(0);
   } else if ((chr >= 'a') && (chr <= 'f')) {
      *val = chr-'a'+10;
      return(0);
   } else {
      return(1);
   }
}

/****************************************************************************/
/* calculates the numeric value of an ASCII string representing an hexa number
   parameters:
      strx -> ASCII string representing an hexa number
      siz -> number of digits to evaluate
      val -> pointer where the conversion is returned
   returns:
      0 -> conversion OK, <>0 fail conversion
   modifies:
      val
*/
unsigned char CD_HexaStrTo_u8(unsigned char *strx, unsigned char siz, unsigned char *val) {

   unsigned char tmp;

   if (siz == 1) {
      if (CD_HexaToNum(strx[0], val)) {
         return(1);  // fail
      } else {
         return(0);
      }
   } else if (siz == 2) {
      if (CD_HexaToNum(strx[0], &tmp)) {
         return(1);  // fail
      } else {
         if (CD_HexaToNum(strx[1], val)) {
             return(1);  // fail
          } else {
             tmp <<= 4;
             *val |= tmp;
             return(0);
          }
      }
   } else { /* siz too big */
      return(2);
   }
}

/****************************************************************************/
/* calculates the numeric value of an ASCII string representing an hexa number
   parameters:
      strx -> ASCII string representing an hexa number
      siz -> number of digits to evaluate
      val -> pointer where the conversion is returned
   returns:
      0 -> conversion OK, <>0 fail conversion
   modifies:
      val
*/
unsigned char CD_HexaStrTo_u16(unsigned char *strx, unsigned char siz, unsigned int *val) {

   unsigned char tmp;
   unsigned char i;
   unsigned int tmp2;

   if (siz <0 || siz >4) {
      return(2);  // number of digits incorrect
   }

   tmp2 = 0;
   for (i=0;i<siz;i++) {
      if (CD_HexaToNum(strx[i], &tmp)) {
         return(1);  // fail
      } else {
         tmp2 <<= 4;
         tmp2 |= tmp;
      }
   }
   *val = tmp2;
   return(0);
}

/****************************************************************************/
/* calculates the numeric value of an ASCII string representing an hexa number
   parameters:
      strx -> ASCII string representing an hexa number
      siz -> number of digits to evaluate
      val -> pointer where the conversion is returned
   returns:
      0 -> conversion OK, <>0 fail conversion
   modifies:
      val
*/
unsigned char CD_HexaStrTo_u32(unsigned char *strx, unsigned char siz, unsigned long *val) {

   unsigned char tmp;
   unsigned char i;
   unsigned long tmp2;

   if (siz <0 || siz >8) {
      return(2);  // number of digits incorrect
   }

   tmp2 = 0;
   for (i=0;i<siz;i++) {
      if (CD_HexaToNum(strx[i], &tmp)) {
         return(1);  // fail
      } else {
         tmp2 <<= 4;
         tmp2 |= tmp;
      }
   }
   *val = tmp2;
   return(0);
}

