/*
    File: cdm_Link.c
    Data from/to HOST management (sending,...)
    Angel Perles. May 2009. May 2010.
    Version for qt (depends on qextserialport project)

*/


#include <qextserialport.h>

static bool serial_ready = false;
static QextSerialPort *port = 0; // pointer to the serial port handler


/****************************************************************************/
/* Module initilization                                                     */
/* in this implementation, "params" will be de serial port identifier                */
void cdm_LinkInit(const char *params) {

    // test if serial port handler has been created and create it if necessary
    if (port == 0) {
        port = new QextSerialPort();
        port->setQueryMode(QextSerialPort::Polling);  // modo mas sencillo
        serial_ready = false;
    }

    // if port is open, then close it
    if (serial_ready) {
        port->close();
        serial_ready = false;
    }

    // configure port parameters
    port->setPortName(params);
    port->setBaudRate (BAUD9600);
    port->setDataBits(DATA_8);
    port->setStopBits(STOP_1);
    port->setParity(PAR_NONE);
    port->setFlowControl(FLOW_OFF);

    if (!port->open(QextSerialPort::ReadWrite)) {
        //return (CDM_Error_UnableToOpenLink);
        return;
    }

    serial_ready = true;
    //return(CDM_Error_NoError);
    return;
}

