#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

class QLabel;
class QtSvgDialGauge;
class QTimer;


namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void setDial(double value);

public slots:
    void handle_btInit(void);
    void handle_btSend(void);
    void handle_btReceive(void);
    void handle_btTest(void);
    void handle_btDOL0(void);
    void handle_btDOL1(void);
    void handle_vsTestDial(int value);
    void handle_timer(void);
    void handle_sbPWM(int value);

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    QtSvgDialGauge *gauge;
    QLabel *lbDialValue;
    QTimer *timer;
};

#endif // MAINWINDOW_H
